from enum import Enum

import cv2




class AprilTagFamily(Enum):
    '''
    April Tag Families supported by the detector.
    '''
    TAG_16h5 = cv2.aruco.DICT_APRILTAG_16h5
    TAG_25h9 = cv2.aruco.DICT_APRILTAG_25h9
    TAG_36h10 = cv2.aruco.DICT_APRILTAG_36h10
    TAG_36h11 = cv2.aruco.DICT_APRILTAG_36h11


class AprilTagDetection:
    """
    Result object that pairs with :class:`AprilTagDetector`.
    """
    def __init__(self, top_right, top_left, bottom_right, bottom_left, tag_id):
        pass

    def markup_image(self, image, tag_id=False):
        pass

    @property
    def tag_id(self):
        pass

    @property
    def corners(self):
        pass

    def __repr__(self):
        pass

class AprilTagDetector:
    '''
    Class to be used to detect April Tags.

    :type family: :class:`AprilTagFamily`
    :param family: The tag family that you want to detect.
    '''
    def __init__(self, family: AprilTagFamily):
        pass

    def detect(self, image):
        pass

    def __repr__(self):
        pass

