
from edgeiq.base_service import BaseService



class ClassificationPrediction(object):
    """A single prediction from :class:`Classification`."""
    def __init__(self, confidence, label):
        pass

    @property
    def label(self):
        pass

    @property
    def confidence(self):
        pass

    def __repr__(self):
        pass

class ClassificationResults(object):
    """
    All the results of classification from :class:`Classification`.

    Predictions are stored in sorted order, with descending order of
    confidence.
    """
    def __init__(self, confidences, labels, start, end, image):
        pass

    @property
    def duration(self):
        pass

    @property
    def predictions(self):
        pass

    @property
    def image(self):
        pass

    def __repr__(self):
        pass

class Classification(BaseService):
    """
    Identify the most prominent object in an image.

    Typical usage::

        classifier = edgeiq.Classification('alwaysai/googlenet')
        classifier.load(engine=edgeiq.Engine.DNN)

        <get image>
        results = classifier.classify_image(image)
        for prediction in results.predictions:
            print('Label: {}, confidence: {}'.format(
                prediction.label, prediction.confidence))

    :type model_id: string
    :param model_id: The ID of the model you want to use for image
                     classification.
    """
    def __init__(self, model_id):
        pass

    def classify_image(self, image, confidence_level=.3):
        pass

