



class MjpgVideoWriter:
    """
    Host an MJPG video streaming server on the device.

    MJPG video streams can be consumed by third-party apps such as VLC.

    `MjpgVideoWriter` can be instantiated as a context manager::

        with edgeiq.MjpgVideoWriter() as video_writer:
            ...
            video_writer.write_frame(frame)
            ...

    To use `MjpgVideoWriter` directly, use the
    :func:`~edgeiq.mjpg_video_writer.MjpgVideoWriter.start()`
    and :func:`~edgeiq.mjpg_video_writer.MjpgVideoWriter.close()` functions::

        video_writer = edgeiq.MjpgVideoWriter().start()
        ...
        video_writer.write_frame(frame)
        ...
        video_writer.close()

    :type queue_depth: integer
    :param queue_depth: The depth of the data queue used for communication
                        between the application process and server process.
    """
    def __init__(self,
                 queue_depth=2,
                 port=5000,
                 max_image_width=640,
                 max_image_height=480,
                 jpg_quality=75,
                 **kwargs):
        pass

    def start(self):
        pass

    def write_frame(self, frame):
        pass

    def close(self):
        pass

    def __enter__(self):
        pass

    def __exit__(self, type, value, traceback):
        pass

    def __del__(self):
        pass

def gen_video_feed():
    pass

@_app.route('/video')
def video():
    pass

