import logging

import cv2

from edgeiq.base_service import BaseService



class Pose(object):
    def __init__(self, key_points, score):
        pass

    @property
    def key_points(self):
        pass

    @property
    def score(self):
        pass

    def __repr__(self):
        pass

class HumanPoseResult:
    """
    The results of pose estimation from
    :class:`~edgeiq.pose_estimation.PoseEstimation`.
    """

    # _layer_names = ['Mconv7_stage2_L1', 'Mconv7_stage2_L2']
    def __init__(self, poses, image, input_dimension, start, end, **kwargs):
        pass

    @property
    def image(self):
        pass

    @property
    def poses(self):
        pass

    @property
    def duration(self):
        pass

    def draw_poses_background(self, color):
        pass

    def draw_poses(self, image=None):
        pass

    def __repr__(self):
        pass

    def draw_aliens(self):
        pass

class PoseEstimation(BaseService):
    """
    Find poses within an image.

    Typical usage::

        pose_estimator = edgeiq.PoseEstimation("alwaysai/human-pose")
        pose_estimator.load(engine=edgeiq.Engine.DNN)

        <get image>
        results = pose_estimator.estimate(image)

        for ind, pose in enumerate(results.poses):
                    print('Person {}'.format(ind))
                    print('-'*10)
                    print('Key Points:')
                    for key_point in pose.key_points:
                        print(str(key_point))
        image = results.draw_poses(image)

    :type model_id: string
    :param model_id: The ID of the model you want to use for pose estimation.
    """
    def __init__(self, model_id):
        pass

    def estimate(self, image):
        pass

if __name__ == '__main__':
    from edgeiq import Engine, Accelerator

    logging.basicConfig(level=logging.DEBUG)
    hs = PoseEstimation('alwaysai/human_pose')
    hs.load(Engine.DNN_OPENVINO, Accelerator.MYRIAD)
    image_ = cv2.imread('soccer2.jpg')
    pose_result = hs.estimate(image_)
    pose_result.draw_poses(image_)
    cv2.imwrite('pointers.png', image_)

