from edgeiq import edge_tools

if edge_tools.is_jetson():
    import tensorrt as trt
    if trt.__version__[0] < '7':
        raise RuntimeError(
            'Only TensorRT 7.0 + is supported, please update your system')
    import ctypes
    import os
    if edge_tools.is_jetson_xavier_nx():
        try:
            folder = os.path.dirname(os.path.abspath(__file__))
            dll_path = os.path.join(folder,
                                    "ext_libs/yolo_trt/libyolo_layer_nx.so")
            ctypes.cdll.LoadLibrary(dll_path)
        except OSError:
            raise SystemExit('failed to load libyolo_layer.so')
    elif edge_tools.is_jetson_nano():
        try:
            folder = os.path.dirname(os.path.abspath(__file__))
            dll_path = os.path.join(folder,
                                    "ext_libs/yolo_trt/libyolo_layer_nano.so")
            ctypes.cdll.LoadLibrary(dll_path)
        except OSError:
            raise SystemExit('failed to load libyolo_layer.so')
    elif edge_tools.is_jetson_tx2():
        try:
            folder = os.path.dirname(os.path.abspath(__file__))
            dll_path = os.path.join(folder,
                                    "ext_libs/yolo_trt/libyolo_layer_tx2.so")
            ctypes.cdll.LoadLibrary(dll_path)
        except OSError:
            raise SystemExit('failed to load libyolo_layer.so')
    else:
        raise AssertionError('this device is not supported!')
