import logging

LOGGER = logging.getLogger(__name__)


def enumerate_realsense_cameras():
    pass

class RealSenseFrame:
    def __init__(self, depth_frame, color_frame, depth_scale):
        pass

    @property
    def image(self):
        pass

    @property
    def depth(self):
        pass

    def render_depth_image(self):
        pass

    def roi(self, min=None, max=None, shade=160):
        pass

    def compute_object_distance(self, obj):
        pass

    def compute_distance_between_objects(self, box1, box2):
        pass

    def get_serializable_realsense_frame(self):
        pass

class SerializableRealSenseFrame(RealSenseFrame):
    def __init__(
            self, depth_array, color_array, depth_scale):
        pass

    def compute_object_distance(self, obj):
        pass

    def compute_distance_between_objects(self, box1, box2):
        pass

class RealSense:
    """
    A set of methods that can be used with a RealSense camera(s) for getting
    the distances to objects, capturing regions of interest based on
    distance, displaying video streams and depth maps.

    Typical usage::

        with edgeiq.RealSense() as video_stream:
            while True:
                rs_frame = video_stream.read()
                results = obj_detect.detect_objects(
                         rs_frame.color_frame, confidence_level=.5)

                for prediction in results.predictions:
                        distance = rs_frame.compute_object_distance(
                            prediction.box)

    :type device_serial_number: string
    :param device_serial_number: The serial number of the realsense device to
                                 use obtained from the
                                 :func:`~edgeiq.realsense.enumerate_realsense_cameras`
                                 function. If set to `None` the first discovered
                                 RealSense camera will be used.
    """
    def __init__(self, device_serial_number=None):
        pass

    def start(self):
        pass

    def read(self):
        pass

    def __enter__(self):
        pass

    def __exit__(self, type, value, traceback):
        pass

    def __del__(self):
        pass

    def stop(self):
        pass

